## 版本控制规范

### 代码提交规范按照：`类型 #issueid 描述`
说明：提交信息分三段，以空格隔开

类型：用于说明 commit 的类别，只允许使用下面7个标识。

- `feat`：新功能（feature）
- `fixed`：修补bug
- `docs`：文档（documentation）
- `style`： 格式（不影响代码运行的变动）
- `refactor`：重构（即不是新增功能，也不是修改bug的代码变动）
- `test`：增加测试
- `chore`：构建过程或辅助工具的变动
- `done`：通用任意类型都可以使用
- `doing`：同上不同在于更新到redmine的进度和状态
- `fixed`、`done`、`task`、`feat`类型的提交在redmine中会被标识为已解决，后续供测试人员验证，通过则关闭，反之返回重开状态

#### `#issueid`：
redmine中已经存在的id
#### `描述`：
针对这次提交的描述

例如

- 修复bug：
`fixed		#123		修复账号多处登录无法登录问题`
按照这个格式提交那么问题会被自定修改为已解决，完成度变成100%

完成功能:
`done		#312		第三方微信注册功能完成`
按照这个格式提交那么问题会被自定修改为已解决，完成度变成100%

进行中：
`doing		#213		修改密码功能开发中`
按照这个格式提交那么问题会被自定修改为进行中，完成度变成30%

完成任务：
`task		#123		增加用户信息展示页`
按照这个格式提交那么问题会被自定修改为已解决，完成度变成100%

## 版本控制的意义
1. 可以追溯代码修改历史，便于排查问题和回滚代码
2. 利用版本控制工具进行团队多人协同开发，同时推进，加快开发速度
3. 通过版本控制工具，将代码存在服务器上，可以一定程度防止开发机器故障导致的代码丢失

## 代码拉取和提交流程
现在大部分公司和团队都是在使用 Git 作为版本控制工具，下面的内容都是以 Git 为基准来说的
1. 每天在写代码之前记得先用 pull 命令拉取最新代码（多人协作的情况下）
2. **基于第一条，在 pull 之前记得先把本地修改的代码 commit，不然可能会导致代码冲突且 pull 失败，同时修改过的文件也不见了。这一点非常重要**
3. 在 pull 的时候可能会碰到代码冲突，这时候必须要解决有冲突的代码，冲突的代码不解决轻则程序出错，重则编译不通过
4. 在每天下班之前要将修改过的代码 commit 并 push 到仓库中
5. 基于第四条，在多人协作时，commit 之后记得先 pull 一下最新的代码再 push，因为仓库中可能有他人提交的代码

## 代码提交时机
1. 完成了某个功能或模块之后
2. 修复了某个 bug 之后

**总之就是必须做到细粒度的提交，不要一次性很多功能和模块同时提交，那样就失去了版本控制的意义**

## 提交信息
每次 commit 的时候，commit message 必须填写，并且必须要写清楚该次 commit 修改或者修复了什么内容。
版本控制的作用就是为了追溯代码变化，如果没有提交信息，别人根本就不知道你这次提交是做了什么事情，要想知道都干了啥还得把全部修改的代码都看一遍，
这显然是不现实和非常浪费时间的，所以每次的 commit message 必须填写并且要写清楚。
同时这也是与前面说的提交时机相对应的，每次都做到细粒度的提交，那么提交信息都不会很多，也方便后期问题查找和追溯。
